package org.dromara.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.domain.bo.SenEventsObjectBo;
import org.dromara.domain.vo.SenEventsObjectVo;
import org.dromara.domain.SenEventsObject;
import org.dromara.mapper.SenEventsObjectMapper;
import org.dromara.service.ISenEventsObjectService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 事件对象Service业务层处理
 *
 * @author luogang
 * @date 2024-09-19
 */
@RequiredArgsConstructor
@Service
public class SenEventsObjectServiceImpl implements ISenEventsObjectService {

    private final SenEventsObjectMapper baseMapper;

    /**
     * 查询事件对象
     *
     * @param id 主键
     * @return 事件对象
     */
    @Override
    public SenEventsObjectVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询事件对象列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 事件对象分页列表
     */
    @Override
    public TableDataInfo<SenEventsObjectVo> queryPageList(SenEventsObjectBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SenEventsObject> lqw = buildQueryWrapper(bo);
        Page<SenEventsObjectVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的事件对象列表
     *
     * @param bo 查询条件
     * @return 事件对象列表
     */
    @Override
    public List<SenEventsObjectVo> queryList(SenEventsObjectBo bo) {
        LambdaQueryWrapper<SenEventsObject> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SenEventsObject> buildQueryWrapper(SenEventsObjectBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SenEventsObject> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getEventId() != null, SenEventsObject::getEventId, bo.getEventId());
        lqw.eq(StringUtils.isNotBlank(bo.getObjectType()), SenEventsObject::getObjectType, bo.getObjectType());
        lqw.eq(StringUtils.isNotBlank(bo.getEventType()), SenEventsObject::getEventType, bo.getEventType());
        lqw.eq(StringUtils.isNotBlank(bo.getObjectId()), SenEventsObject::getObjectId, bo.getObjectId());
        lqw.eq(StringUtils.isNotBlank(bo.getObjectAttr()), SenEventsObject::getObjectAttr, bo.getObjectAttr());
        return lqw;
    }

    /**
     * 新增事件对象
     *
     * @param bo 事件对象
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SenEventsObjectBo bo) {
        SenEventsObject add = MapstructUtils.convert(bo, SenEventsObject.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改事件对象
     *
     * @param bo 事件对象
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SenEventsObjectBo bo) {
        SenEventsObject update = MapstructUtils.convert(bo, SenEventsObject.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SenEventsObject entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除事件对象信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
